/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"
#include "combfilters.h"
#include "math.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;


#define SAMPLES_PER_SECOND 16000
#define GAIN_IN_dB 0
#define LENGTH 24000
#define OPOZNIENIE 16000		// < LENGTH -------

unsigned int Step = 0; 
unsigned int LastStep = 99;

int i = 0;

double ALFA = 0.8;			// <---------------
double f3dB;
double omega3dB;

char *napis1 = "1                   ";
char *napis2 = "2                   ";

int bufferEcho[LENGTH];

int FIR_echo(int input, unsigned int length)
{
 static unsigned int index = 0;
 long output;
 long alfa = (long)(0.9 * 32768L);

 /* Check that parameter length is not off the end of the buffer */ 
 if ( length > LENGTH) length = LENGTH;
 
 /* y(n) =  x(n)/2 + x(n-N)/2   Zespolony */
 //output = (input + buffer[index]) >> 1;
 
  /* y(n) =  x(n)/2 - x(n-N)/2  Rzeczywisty*/
  
  output = (alfa * bufferEcho[index]) >> 15;
  output =  _sadd(input, output);

 /* Save new input */

 bufferEcho[index] = input;  
 
// index = ++index % length;
 if(++index >= length) index = 0;

 return ((int) output);
}

int IIR_poglos(int input, unsigned int length, float ALFA)
{
 static unsigned int index = 0;
 long output;
 long alfa = (long)(ALFA * 32768L);

 /* Check that parameter length is not off the end of the buffer */ 
 if ( length > LENGTH) length = LENGTH;

 /* y(n) =  (x(n)+ G. y(n-N) ) * (1+G) Rzeczywisty*/
  output = (alfa * bufferEcho[index]) >> 15;  
 //output += ((long)input * (long)(32768L - alfa))>>15;
 
  output =  _sadd(input, output);

/* y(n) =  (x(n)+ G. y(n-N) ) * (1+G)  Zespolony */
// output = -(alfa * buffer3[index]) >> 15;  
// output += ((long)input * (32768L - alfa))>>15;


 /* Save latest output y(n) */
 bufferEcho[index] = output; 
 
 //index = ++index % length;
  if(++index >= length) index = 0;
 
 return ((int) output);
}






 
/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nLaboratorium FCiPS\n");
    printf( "Badanie echa i pogłosu\n" );
    printf("Opóżnienie = %d [ms]", OPOZNIENIE / (SAMPLES_PER_SECOND / 1000)); 

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Laboratorium FCiPS ", "Filtry IIR I rzedu    ");

	/* New. Add descriptive text */ 

    puts("\n Przyciskami przełączana jest częstotliwość graniczna filtrów od 1 kHz do 20 kHz co 1 kHz\n");
      
	/* Default to XF LED off */
	asm(" bclr XF");
    
 	for ( ;; )
 	{
     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
   
     mono_input = stereo_to_mono(left_input, right_input);
     
     Step = pushbuttons_read(3);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L; bez zmiany ", "P = P; bez zmiany ");
           puts("\n0 Transmisja sygnału z wejścia na wyjście");
           LastStep = Step;
          }	
         left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;

	    } 
	  if ( Step == 2)
        {
         if ( Step != LastStep )
          {
   
           printf("2 -> Echo\n");
           oled_display_message("Echo      ", "Echo      ");
           LastStep = Step;
          }	         
         left_output = FIR_echo(left_input, OPOZNIENIE);         
         right_output = left_output; 
         
	    } 
        
        if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           printf("3 -> Pogłos\n");
           oled_display_message("poglos   ", "poglos   ");
           for(i=0; i<LENGTH; i++)
           	bufferEcho[i] = 0;
           
           
           LastStep = Step;
          }	
         left_output = IIR_poglos(left_input, OPOZNIENIE, ALFA);         
         right_output = left_output; 
         
	    } 
        
        
	    	  	    
     aic3204_codec_write(left_output, right_output);
 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
